#include <jni.h>

#ifdef _WIN32
#define PATH_SEPARATOR ';'
#else /* UNIX */
#define PATH_SEPARATOR ':'
#endif

#define USER_CLASSPATH "." /* where Prog.class is */


#include <math.h>
#include "mex.h"



void mexFunction(int nlhs,       mxArray *plhs[],
                 int nrhs, const mxArray *prhs[] ) {

    JNIEnv *env;
    JavaVM *vm;
//    JDK1_1InitArgs vm_args;
    jint res;
    jclass cls;
    jmethodID mid;
    jstring jstr;
    jobjectArray args;
    char classpath[1024];

    JavaVMInitArgs vm_args;
     JavaVMOption options[4];

    /* Append USER_CLASSPATH to the end of default system class path */
 //   sprintf(classpath, "%s%c%s",
 //           vm_args.classpath, PATH_SEPARATOR, USER_CLASSPATH);
 //   vm_args.classpath = classpath;



     options[0].optionString = "-Djava.compiler=NONE";           /* disable JIT */
     options[1].optionString = "-Djava.class.path=c:\\mueller\\web\\jmatlink"; /* user classes */
     options[2].optionString = "-Djava.library.path=c:\\mueller\\web\\jmatlink";  /* set native library path */
     options[3].optionString = "-verbose:jni";                   /* print JNI-related messages */

     vm_args.version = JNI_VERSION_1_2;
     vm_args.options = options;
     vm_args.nOptions = 4;
     vm_args.ignoreUnrecognized = 1; //???? TRUE;

     /* Note that in JDK 1.2, there is no longer any need to call 
      * JNI_GetDefaultJavaVMInitArgs. 
      */


     res = JNI_CreateJavaVM(&vm, (void **)&env, &vm_args);
    if (res < 0) {
        printf("Can't create Java VM\n");
        return;
    }
    else printf("Java VM created\n");

    cls = (*env)->FindClass(env, "TestGui");
    if (cls == 0) {
        printf("Can't find Prog class\n");
        return;
    }
    else printf("found Prog class\n");
 
    mid = (*env)->GetStaticMethodID(env, cls, "main", "([Ljava/lang/String;)V");
    if (mid == 0) {
        printf("Can't find Prog.main\n");
        return;
    }
    else printf("found prog.man\n");

    jstr = (*env)->NewStringUTF(env, " from C!");
    if (jstr == 0) {
        printf("Out of memory\n");
        return;
    }
    args = (*env)->NewObjectArray(env, 1, 
                        (*env)->FindClass(env, "java/lang/String"), jstr);
    if (args == 0) {
        printf("Out of memory\n");
        return;
    }
    printf("asdasasfd\n");
    (*env)->CallStaticVoidMethod(env, cls, mid, args);

//    (*vm)->DestroyJavaVM(vm);
return;
}

